//---------------------------------------------------------------------------

#ifndef UColaIterH
#define UColaIterH
#include "UtLista.h"
//---------------------------------------------------------------------------

template <class T> class ColaIter : protected Lista<T>
{
public:
        ColaIter():Lista<T>() {};
        virtual ~ColaIter() throw() {};
        unsigned int size() const throw() {return Lista<T>::size();};
        bool empty() const throw() {return Lista<T>::empty();};
        void clear() throw() {Lista<T>::clear();};
        void push(const T& E) throw(bad_alloc) {Lista<T>::push_back(E);}; //apila el elemento E.
//        bool pop() throw() {try(Lista<T>};
        void pop() throw(ErrVacia) {try{Lista<T>::pop_front();}catch(ErrVacia){}}; //desapila la cima si la pila no est vaca.
        bool front(T& E) const throw() {try {E = Lista<T>::front(); return true;} catch(Error) {return false;}};
        const T& front() const throw(ErrVacia) {return Lista<T>::front()}; //devuelven la cima si la pila no est vaca.
//Y los mtodos para recorrer los elementos de la cola, su implementacin usar los mtodos del pi:
        bool iniciaIter() throw()
        {
                iniciaPI();
                if(empty())
                {
                        return false;
                }
                else return true;
        };
//        void iniciaIter() throw(ErrVacia); // posicionan el punto de inters en la cima.
        bool avanzaIter() throw()
        {
                avanzaPI();
                return (contPI() < size());
        };
/*        const T& avanzaIter() throw(ErrIter)
        {
                avanzaPI();
                return elemPI();
        }; //avanzan el punto de inters al siguiente.
*/        bool actualIter (T& E) throw()
        {
                if(contPI() < size())
                {
                        E = elemPI();
                        return true;
                }
                else return false;
        };
        const T& actualIter() throw(ErrIter)
        {
                if(contPI() < size())
                {
                        return elemPI();
                }
/*                else
                {
                        ErrIter error;
                        throw error;
                }*/
        };// devuelven el elemento sealado.
};

#endif

