//---------------------------------------------------------------------------

#ifndef UtArbolJT2H
#define UtArbolJT2H

#include "UtArbol.h"
#include "UtJuegoLogT2.h"
//---------------------------------------------------------------------------

struct datoT2
{
        tJuegoLogT2* juego;
        Casilla jugada;
};

typedef Arbol<datoT2> ArbolJ;

typedef int (*FunHeuristicaT2) (const tJuegoLogT2& EC);

class ArbolJT2
{
public:
        ArbolJT2(const tJuegoLogT2& EJ, int nivel, FunHeuristicaT2 fh);
        ~ArbolJT2() {liberaArbol(arbol); delete arbol;};
        Casilla buscaMejorJugada() throw(EJugador);

protected:
        ArbolJ* arbol;
        int buscaMiniMax(ArbolJ* a);
        void liberaArbol(ArbolJ* a);
        void generaArbol(ArbolJ* arbol, int nivel);
        int nivel;
        FunHeuristicaT2 FH;
};

#endif
