//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "UtInterfazGrafC4.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

tBMP tInterfazGrafC4::fichaA("fichaA.bmp");
tBMP tInterfazGrafC4::fichaB("fichaB.bmp");
tBMP tInterfazGrafC4::fichaN("fichaN.bmp");

void tInterfazGrafC4::muestraEstado(const tJuegoLogT2& EJ) const throw (EInterfaz)
{
        Turno aux;
        lienzo->Brush->Color = clBtnFace;
        lienzo->Font->Name = "Arial";
        lienzo->Font->Size = 18;
        lienzo->Font->Color = clBlack;
        AnsiString str;

        if(EJ.getTurno() == Ja)
        {
                str = "Turno: Jugador 1";
                TSize x = lienzo->TextExtent(str);
                lienzo->TextOut((anchoTablero / 2) - (x.cx / 2), altoTablero + (x.cy / 2), str);
        }
        else
        {
                str = "Turno: Jugador 2";
                TSize x = lienzo->TextExtent(str);
                lienzo->TextOut((anchoTablero / 2) - (x.cx / 2), altoTablero + (x.cy / 2), str);
        }

        for(unsigned int i = 0; i < EJ.getCols(); i++)
        {
                for(unsigned int j = 0; j < EJ.getFils(); j++)
                {
                        EJ.getTablero()->getElem(i, j, aux);
                        switch(aux)
                        {
                                case Ja:
                                        lienzo->Draw(i * ladoCasilla, j * ladoCasilla, fichaA.BMP());
                                        break;
                                case Jb:
                                        lienzo->Draw(i * ladoCasilla, j * ladoCasilla, fichaB.BMP());
                                        break;
                                default:
                                        lienzo->Draw(i * ladoCasilla, j * ladoCasilla, fichaN.BMP());
                                        break;
                        }
                }
        }

} // dibuja en lienzo el estado del juego EJ.

