//---------------------------------------------------------------------------

#ifndef UtJuegoConecta4H
#define UtJuegoConecta4H
//---------------------------------------------------------------------------

#include "UtJuegoLogT2.cpp"

class tJuegoConecta4: public tJuegoLogT2
{
public:
        tJuegoConecta4(const tJuegoConecta4& juego); //:tJuegoLogT2(juego) {this->libres = libres;};
        tJuegoConecta4(unsigned int c = 8, unsigned int f = 6, Turno t = Ja):tJuegoLogT2(c, f, t) {libres = c * f;};

        virtual void aplicaJugada(unsigned int c,unsigned int f) throw(EJuego); //: mtodo abstracto que aplica la jugada caracterizada por la posicin (c,f) del tablero. Si dicha jugada no es legal se lanza una excepcin.
        virtual bool sePuede(unsigned int c,unsigned int f) const throw(); // : dice si la jugada caracterizada por (c,f) es una jugada legal.
        virtual bool fin() const throw(); //: indica si no se pueden realizar ms jugadas.
        virtual tJuegoLogT2* clona() const; //: devuelve un puntero a una copia del juego actual.

private:
        int libres;
};

#endif
