//---------------------------------------------------------------------------

#ifndef UtInterfazGrafC4H
#define UtInterfazGrafC4H

#include "UtInterfazGrafT2.h"
//---------------------------------------------------------------------------

class tInterfazGrafC4: public tInterfazGrafT2
{
public:
        tInterfazGrafC4(TCanvas* l = NULL):tInterfazGrafT2(l) {};
        ~tInterfazGrafC4() {};
        static tBMP fichaA, fichaB, fichaN;
        static const int ladoCasilla = 50;
        static const int altoTablero = 300;
        static const int anchoTablero = 400;

        virtual unsigned int dameColumna(unsigned int X) const throw (EInterfaz) {return X / ladoCasilla;}; // devuelve la columna del tablero correspondiente a la coordenada X.
        virtual unsigned int dameFila(unsigned int Y) const throw (EInterfaz) {return 0;}; //Y / ladoCasilla;}; // devuelve la fila del tablero correspondiente a la coordenada Y.
        virtual unsigned int dameAnchoGraf() const throw() {return anchoTablero;}; // devuelve el ancho total que utiliza muestraEstado.
        virtual unsigned int dameAltoGraf() const throw() {return altoTablero;}; // anlogo al anterior.

        virtual void muestraEstado(const tJuegoLogT2& EJ) const throw (EInterfaz); // dibuja en lienzo el estado del juego EJ.
};

#endif
