//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "UtInterfazGrafOt.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

tBMP tInterfazGrafOt::fichaA("OteloA.bmp");
tBMP tInterfazGrafOt::fichaB("OteloB.bmp");
tBMP tInterfazGrafOt::fichaN("OteloN.bmp");
tBMP tInterfazGrafOt::barraPaso("OteloP.bmp");

void tInterfazGrafOt::muestraEstado(const tJuegoLogT2& EJ) const throw (EInterfaz)
{
        Turno aux;
        AnsiString str;
        TSize x;
        lienzo->Brush->Color = clBtnFace;
        lienzo->Font->Name = "Arial";
        lienzo->Font->Size = 10;
        lienzo->Font->Color = clBlack;
        const tJuegoLogT2* a = &EJ;

        if(EJ.getTurno() == Ja)
        {
                str = "Turno: Jugador 1";
                x = lienzo->TextExtent(str);
                lienzo->TextOut((anchoTablero / 2) - (x.cx / 2), altoTablero + (x.cy / 2), str);
        }
        else
        {
                str = "Turno: Jugador 2";
                x = lienzo->TextExtent(str);
                lienzo->TextOut((anchoTablero / 2) - (x.cx / 2), altoTablero + (x.cy / 2), str);
        }
        str = "J1: ";
        if(dynamic_cast<const tJuegoOtelo*>(a)->getFichasJa() < 10) str = str + "0";
        str = str + IntToStr(dynamic_cast<const tJuegoOtelo*>(a)->getFichasJa()) + " J2: ";
        if(dynamic_cast<const tJuegoOtelo*>(a)->getFichasJb() < 10) str = str + "0";
        str = str + IntToStr(dynamic_cast<const tJuegoOtelo*>(a)->getFichasJb());
        x = lienzo->TextExtent(str);
        lienzo->TextOut((anchoTablero / 2) - (x.cx / 2), altoTablero + (3 * (x.cy / 2)), str);

        for(unsigned int i = 0; i < EJ.getCols(); i++)
        {
                for(unsigned int j = 0; j < EJ.getFils(); j++)
                {
                        EJ.getTablero()->getElem(i, j, aux);
                        switch(aux)
                        {
                                case Ja:
                                        lienzo->Draw(i * ladoCasilla, j * ladoCasilla, fichaA.BMP());
                                        break;
                                case Jb:
                                        lienzo->Draw(i * ladoCasilla, j * ladoCasilla, fichaB.BMP());
                                        break;
                                default:
                                        lienzo->Draw(i * ladoCasilla, j * ladoCasilla, fichaN.BMP());
                                        break;
                        }
                }
        }
        lienzo->Draw(8 * ladoCasilla, 0, barraPaso.BMP());
}