//---------------------------------------------------------------------------

#ifndef UtJugadorAutC4H
#define UtJugadorAutC4H

#include "UtJugadorAutT2.h"
#include "UtArbolJT2.h"
#include "UtJuegoConecta4.h"
//---------------------------------------------------------------------------

class tJugadorAutC4: public tJugadorAutT2
{
public:
        tJugadorAutC4() {};
        ~tJugadorAutC4() {};
        virtual Casilla juega(const tJuegoLogT2& EJ) throw (EJugador) = 0;
};

class tJugAleaC4: public tJugadorAutC4
{
public:
        tJugAleaC4() {};
        ~tJugAleaC4() {};
        virtual Casilla juega(const tJuegoLogT2& EJ) throw (EJugador);
};

typedef int (*FunHeuristicaC4)(const tJuegoConecta4&);

int heurisC4 (const tJuegoConecta4& EJ);
void heurisAuxC4(int& cont, Turno a1, Turno a2, Turno a3, Turno a4);

class tJugConzC4: public tJugadorAutC4
{
public:
        tJugConzC4(int nivel = 2) {this->nivel = nivel; heuristica = heurisC4;};
        ~tJugConzC4() {};
        virtual Casilla juega(const tJuegoLogT2& EJ) throw (EJugador);

private:
        int nivel;
        FunHeuristicaC4 heuristica;
};

#endif
